#include "hp34401.h"
#include <cvirte.h>		
#include <userint.h>
#include "Voltmetar.h"
#include <formatio.h>

ViSession instrumentHandle;                          //Instrument handle
ViStatus errStatus; 


static int panelHandle;

int main (int argc, char *argv[])
   {
   if (InitCVIRTE (0, argv, 0) == 0)
      return -1;	/* out of memory */
   if ((panelHandle = LoadPanel (0, "Voltmetar.uir", PANEL)) < 0)
	  return -1;
   DisplayPanel (panelHandle);
   RunUserInterface ();
   DiscardPanel (panelHandle);
   return 0;
   }

int CVICALLBACK PANELCB (int panel, int event, void *callbackData,int eventData1, int eventData2)
   {
   switch (event)
      {
	  case EVENT_CLOSE:
		 QuitUserInterface(0);
		 break;
	  }
   return 0;
   }


/************************************************************************/
/* Callback funkcija PowerOn (vrsi inicijalizaciju)                     */
/************************************************************************/


int CVICALLBACK PowerOn (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
   {
   int  state; unsigned char disp[256]  ; 
   switch (event)
      {
	  case EVENT_LEFT_CLICK:
	     
		 GetCtrlVal (panelHandle, PANEL_BINARYSWITCH, &state);
         
		 switch (state) 
            {
            case 1 :
	           errStatus =hp34401_close (instrumentHandle); 
		       hp34401_error_message(instrumentHandle,errStatus,disp);
		       
		       if (VI_SUCCESS > errStatus)
			      {
			      SetCtrlVal (panelHandle, PANEL_BINARYSWITCH, 0);
				  MessagePopup("",disp);
				  }
			   break; 
            case 0 :
		       {
		       errStatus =hp34401_init ("GPIB0::15::INSTR",1,1, /*VI_TRUE, VI_TRUE,*/ &instrumentHandle);
		       
			   
			   hp34401_error_message(instrumentHandle,errStatus,disp);
			   
		       if (VI_SUCCESS > errStatus)
			      {
				  SetCtrlVal (panelHandle, PANEL_BINARYSWITCH, 1);
				  MessagePopup("",disp);
				  }
			   break;
			}  }
         break;
      }
   return 0;
   }

/************************************************************************/
/* Callback funkcija SelectDCV (prebacuje instrument u rezim DCV)       */
/************************************************************************/

int CVICALLBACK SelectDCV (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   int digits  ;
   double intTime=0.02;//vreme integracije u periodima mreznog napona
   switch (event)
      {
	  case EVENT_COMMIT:
         
		 hp34401_confVoltDc(instrumentHandle);
         
		 //uvek je autoRange nakon reseta
		 hp34401_voltDcRangAuto(instrumentHandle,VI_TRUE);
		 
		 
		 
		 //vreme integracije u periodama mreznog napona
		 
         hp34401_voltDcNplc(instrumentHandle, intTime);
		 
		 
		 
		 break;
      }
   return 0;
   }

/************************************************************************/
/* Callback funkcija MeasureDCV  (vrsi merenje)                         */
/************************************************************************/

int CVICALLBACK MeasureDCV (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   ViReal64 value;
   char str[100];
   ViInt32  measurementNumber;
   int  triggerType;
   switch (event)
      {
	  case EVENT_COMMIT:
		  
		  
		  
		 hp34401_timeOut (instrumentHandle, 100000);//timeout za IO na IEEE488 vezi
		 
		 hp34401_autoZero(instrumentHandle, VI_TRUE);
		 
		  
		 hp34401_trigSour(instrumentHandle,2);//immediate trigger
		 
		 
		 hp34401_sampCoun(instrumentHandle,1); //Broj semplova=1
		 
		 hp34401_trigCoun(instrumentHandle,1); //Broj trigera =1
		 
		 
		 
		 
		 
		 hp34401_trigDelAuto(instrumentHandle, VI_FALSE); //Auto Delay nema
		 
		 
		 
		 hp34401_initImm(instrumentHandle);//Pocetak merenja
		 
		 
		 hp34401_fetc_Q(instrumentHandle, &value, &measurementNumber);//preuzimanje podataka 
		 
		 
		 
		 
		 
		 Fmt (str, "%f", value);
		 SetCtrlVal (panelHandle, PANEL_TEXTMSG_2, str);
      }
   return 0;
   }
